#include <amxmodx>
#include <fakemeta>

static const PLUGIN_NAME[] 	= "Bloody Corpses"
static const PLUGIN_AUTHOR[] 	= "se7h"
static const PLUGIN_VERSION[]	= "1.42"

new g_LastWeapon[33], g_LastAmmo[33], g_max_clients, bool:g_wounded[33]
new gSprBloodDecal[8], gradius[4] = {14, 13, 11, 14}
new gorigin[33][4][3], bool:g_is_dead[33], Float:gfCorpsestay[33]
new spr_blood_drop, spr_blood_spray, Float:gfDeathtime[33]

new hitflesh[4][] = 
{
	"weapons/knife_hit1.wav",
	"weapons/knife_hit2.wav",
	"weapons/knife_hit3.wav",
	"weapons/knife_hit4.wav"
}

new scream[4][] =
{
	"player/death6.wav",
	"player/die1.wav",
	"player/die2.wav",
	"player/die3.wav"
}

new pain[5][] =
{
	"player/pl_pain2.wav",
	"player/pl_pain4.wav",
	"player/pl_pain5.wav",
	"player/pl_pain6.wav",
	"player/pl_pain7.wav"	
}

public plugin_init()
{
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR)

	register_forward(FM_EmitSound, "fwEmitSound")

	register_event("ClCorpse", "event_cl_corpse", "a")
	register_event("HLTV", "new_round", "a", "1=0", "2=0")
	register_event("CurWeapon", "event_curweapon", "be", "1=1")

	g_max_clients = global_get(glb_maxClients)

	new mod[9]
	get_modname(mod, 8)

	if(equali(mod, "cstrike"))
	{
		gSprBloodDecal = {190,191,192,193,194,195,196,197}
	}
	else if(equali(mod, "czero"))
	{
		gSprBloodDecal = {202,203,204,205,206,207,208,209}
	}
}

public plugin_precache()
{
	spr_blood_drop = precache_model("sprites/blood.spr")
	spr_blood_spray = precache_model("sprites/bloodspray.spr")
}

public client_connect(id) 
{ 
    if(!is_user_bot(id)) 
        query_client_cvar(id, "cl_corpsestay", "func_cvar")
}

public func_cvar(id, const cvar[], const value[]) 
	gfCorpsestay[id] = str_to_float(value)

public new_round()
{
	arrayset(g_is_dead, false, sizeof g_is_dead)
	
	static p[32], num, i
	get_players(p, num, "ac") 
	for(i=0; i<num; i++)
		query_client_cvar(p[i], "cl_corpsestay", "func_cvar")
}

public event_cl_corpse()
{
	static id
	id = read_data(12)

	if(!is_user_connected(id))
		return

	g_is_dead[id] = true
	
	g_wounded[id] = (random(2) == 0) ? true : false

	gfDeathtime[id] = get_gametime() + 10.0

	static Float:origin1[3], Float:origin2[3], Float:angle[3]

	engfunc(EngFunc_GetBonePosition, id, 6, origin1, angle)
	FVecIVec(origin1, gorigin[id][0])

	engfunc(EngFunc_GetBonePosition, id, 2, origin2, angle)
	FVecIVec(origin2, gorigin[id][1])

	engfunc(EngFunc_GetBonePosition, id, 32, origin1, angle)
	engfunc(EngFunc_GetBonePosition, id, 37, origin2, angle)
	mid_point(origin1, origin2, gorigin[id][2])

	engfunc(EngFunc_GetBonePosition, id, 33, origin1, angle)
	engfunc(EngFunc_GetBonePosition, id, 38, origin2, angle)
	mid_point(origin1, origin2, gorigin[id][3])
}

public fwEmitSound(id, channel, sound[])
{
	if(!(1 <= id <= g_max_clients) || g_is_dead[id] || !equali(sound, "weapons/knife_hitwall1.wav"))
		return FMRES_IGNORED

	if(g_LastWeapon[id] != CSW_KNIFE || !(pev(id, pev_button) & (IN_ATTACK | IN_ATTACK2)))
		return FMRES_IGNORED

	return doit(id)
}

public event_curweapon(id) 
{
	static WID, Clip
	WID = read_data(2)
	Clip = read_data(3)

	switch(WID)
	{
		case CSW_KNIFE:
		{
			g_LastWeapon[id] = WID 
			return PLUGIN_CONTINUE
		}

		case CSW_HEGRENADE, CSW_FLASHBANG, CSW_SMOKEGRENADE, CSW_C4: return PLUGIN_CONTINUE
	}
	
	if(g_LastWeapon[id] == WID && g_LastAmmo[id] > Clip)
		doit(id)

	g_LastWeapon[id] = WID
	g_LastAmmo[id] = Clip
	
	return PLUGIN_CONTINUE
}

find_dead_body(id, Aim[3], body = 0)
{
	static i, j
	get_user_origin(id, Aim, 3)
	for(i=1; i<=g_max_clients; i++)
	{
		for(j=0; j<4; j++)
		{
			if((get_distance(Aim, gorigin[i][j]) < gradius[j]) && (!body || body == i))
				return i
		}
	}

	return 0
}

stock doit(id)
{
	static Aim[3], Float:fAim[3], Point[3], body, Float:oldtime, Float:curtime
	body = find_dead_body(id, Aim)
	
	curtime = get_gametime()
	
	if(!body || !g_is_dead[body] || (gfDeathtime[body] + gfCorpsestay[id]) < curtime)
	{
		if(g_LastWeapon[id] == CSW_KNIFE)
		{
			get_user_origin(id, Point)
			
			if(get_distance(Aim, Point) < 66)
				sparks(Aim)
		}

		return FMRES_IGNORED
	}

	get_points(id, Aim, Point, fAim)
	func_fx_bloodsprite(Point)
	func_fx_blood_decal(Aim)
	engfunc(EngFunc_EmitAmbientSound, 0, fAim, hitflesh[random(4)], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	if(g_wounded[body] && (curtime - oldtime) > 1.0)
	{
		oldtime = curtime
		g_wounded[body] = (random(3) == 0) ? true : false
		if(g_wounded[body])
			engfunc(EngFunc_EmitAmbientSound, 0, fAim, pain[random(5)], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		else
			engfunc(EngFunc_EmitAmbientSound, 0, fAim, scream[random(4)], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	}

	return FMRES_SUPERCEDE
}

stock get_points(id, const aim[3], out[3], Float:faim[3])
{
	static start[3], Float:fmult, Float:fstart[3], Float:fout[3]
	get_user_origin(id, start, 1)

	IVecFVec(start, fstart)
	IVecFVec(aim, faim)

	fout[2] = faim[2] + random_float(10.0, 12.0)
	fout[0] = faim[2] - fstart[2]
	fmult = (fout[0] == 0.0) ? 0.0 : ((fout[2] - fstart[2])/fout[0])
	fout[0] = fmult*(faim[0] - fstart[0]) + fstart[0]
	fout[1] = fmult*(faim[1] - fstart[1]) + fstart[1]

	FVecIVec(fout, out)
}


stock func_fx_bloodsprite(origin[])
{
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_BLOODSPRITE)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_short(spr_blood_spray)
	write_short(spr_blood_drop)
	write_byte(248)
	write_byte(random_num(4,7))
	message_end()
}

stock func_fx_blood_decal(origin[])
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_WORLDDECAL)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_byte(gSprBloodDecal[random(8)])
	message_end()
}

stock sparks(origin[])
{
	message_begin(MSG_ALL, SVC_TEMPENTITY)
	write_byte(TE_SPARKS)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	message_end()
}

stock mid_point(const Float:origin1[], const Float:origin2[], out[])
{
	out[0] = floatround(origin1[0] + origin2[0])/2
	out[1] = floatround(origin1[1] + origin2[1])/2
	out[2] = floatround(origin1[2] + origin2[2])/2
}

